Attribute VB_Name = "MCreatePicture"
' *************************************************************************
'  Copyright 1999-2001 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (Pic As PictDesc, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long

'typedef struct tagPICTDESC
'{
'    UINT cbSizeOfStruct;
'    UINT picType;
'    Union
'    {
'        struct
'        {
'            HBITMAP hbitmap;
'            HPALETTE hpal;
'        } bmp;
'        struct
'        {
'            HMETAFILE hmeta;
'            int xExt;
'            int yExt;
'        } wmf;
'        struct
'        {
'            HICON hicon;
'        } icon;
'        struct
'        {
'            HENHMETAFILE hemf;
'        } emf;
'    } ;
'} PICTDESC;

Private Type PictDesc
   Size As Long
   Type As Long
   hImage As Long
   Data1 As Long
   Data2 As Long
End Type

Private Type PicBmp
   Size As Long
   Type As Long
   hBmp As Long
   hPal As Long
End Type

Private Type PicIcon
   Size As Long
   Type As Long
   hIcon As Long
End Type

Private Type PicWmf
   Size As Long
   Type As Long
   hMeta As Long
   xExt As Long
   yExt As Long
End Type

Private Type PicEmf
   Size As Long
   Type As Long
   hEmf As Long
End Type

Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(7) As Byte
End Type

Private Const S_OK As Long = 0

Public Function CreatePicture(ByVal hImage As Long, _
   Optional ByVal PicType As PictureTypeConstants = vbPicTypeBitmap, _
   Optional Data1 As Long = 0, Optional Data2 As Long = 0) As IPicture
   
   Dim Pic As PictDesc
   Dim IPic As IPicture
   Dim IID_IDispatch As GUID
   
   ' Fill in with IDispatch Interface ID
   With IID_IDispatch
      .Data1 = &H20400
      .Data4(0) = &HC0
      .Data4(7) = &H46
   End With
   
   ' Fill PictDesc struct with necessary parts
   With Pic
      .Size = Len(Pic)           ' Length of structure
      .Type = PicType            ' Type of Picture
      .hImage = hImage           ' Handle to image
      .Data1 = Data1
      .Data2 = Data2
   End With
   
   ' Create and return Picture object
   If OleCreatePictureIndirect(Pic, IID_IDispatch, False, IPic) = S_OK Then
      Set CreatePicture = IPic
   End If
End Function

Public Function CreateBitmapPicture(ByVal hBmp As Long, Optional hPal As Long = 0) As IPicture
   Dim Pic As PictDesc
   Dim IPic As IPicture
   Dim IID_IDispatch As GUID
   
   ' Fill in with IDispatch Interface ID
   With IID_IDispatch
      .Data1 = &H20400
      .Data4(0) = &HC0
      .Data4(7) = &H46
   End With
   
   ' Fill PicBmp struct with necessary parts
   With Pic
      .Size = Len(Pic)           ' Length of structure
      .Type = vbPicTypeBitmap    ' Type of Picture
      .hImage = hBmp             ' Handle to bitmap
      .Data1 = hPal              ' Handle to palette (may be null)
   End With
   
   ' Create and return Picture object
   If OleCreatePictureIndirect(Pic, IID_IDispatch, True, IPic) = S_OK Then
      Set CreateBitmapPicture = IPic
   End If
End Function


